//************************************************************************************
//**  
//**  File name:     C:\ProjHEX\AVR\PROJEKT\Termostatmega8.c
//**  Generated by:  Flowcode v4.3.6.61
//**  Date:          Sunday, February 13, 2011 00:13:35
//**  Licence:       Professional
//**  Registered to: 20ACM8
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_AVR

//Defines for microcontroller
#define MX_AVR
#define MX_EE
#define MX_EE_SIZE 512
#define MX_SPI
#define MX_SPI_B
#define MX_SPI_SDI 4
#define MX_SPI_SDO 3
#define MX_SPI_SCK 5
#define MX_UART
#define MX_UART_D
#define MX_UART_TX 1
#define MX_UART_RX 0
#define MX_MI2C
#define MX_I2C_C
#define MX_I2C_SDA 4
#define MX_I2C_SCL 5
#define MX_PWM
#define MX_PWM_PORT PORTB
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 DDRB
#define MX_PWM_1 1
#define MX_PWM_TRIS2 DDRB
#define MX_PWM_2 2
#define MX_PWMTYPE 1

//Functions
#define F_CPU 16000000UL
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include <avr\eeprom.h>
#include <avr\wdt.h>
#include <MX_util\delay.h>
#include <MX_util\bit_cmds.h>

//Configuration data
#pragma DATA 0x0, 0xdf
#pragma DATA 0x1, 0xff

//?????????? ???????
#include "C:\Program Files\Matrix Multimedia\Flowcode AVR V4\FCD\internals.h"

//Macro function declarations
char FCM_plus();
char FCM_ust();
short FCM_izm();


//Variable declarations
volatile short FCV_TMP;
volatile char FCV_SW;
volatile char FCV_Z0;
volatile char FCV_Z1;
volatile char FCV_Z2;
volatile short FCV_BN;
volatile short FCV_USTAN;
volatile char FCV_ZNAK;

char FCLV_LOOP1;
char FCLV_LOOP2;

//Defines:

/**** Macro Substitutions ****
0 = Which ADC Channel
40 = Acquisition time
3 = Conversion Speed
0 = VRef+ Option
500 = VRef Voltage x 0.01V
******************************/




//ADC(0): //Macro function declarations

static void FCD_ADC0_SampleADC();
static char FCD_ADC0_ReadAsByte();
static short FCD_ADC0_ReadAsInt();
static float FCD_ADC0_ReadAsVoltage();
static void FCD_ADC0_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE);
//Defines:

/**** Macro Substitutions ****
D = Segment Port
C = Common Port
64 = Pattern 0
121 = Pattern 1
36 = Pattern 2
48 = Pattern 3
25 = Pattern 4
18 = Pattern 5
2 = Pattern 6
120 = Pattern 7
0 = Pattern 8
24 = Pattern 9
255 = Pattern DP
1 = Common Anode
241 = Common Mask Inverted
0 = Segment Mask Inverted
8 = Common Pin 0
4 = Common Pin 1
1 = Common Pin 2
1 = Common Pin 3
******************************/




//led7seg4(0): //Macro function declarations

static void FCD_led7seg40_ShowDigit(char Digit, char Value, char DecimalPoint);
//Defines:
//Error Reading Code For Internal EEPROM::DefinesCode




//EEPROM(0): //Macro function declarations

static char FCD_EEPROM0_EEPROMRead(short addr);
static void FCD_EEPROM0_WriteEEPROM(short addr, char data);



//ADC(0): //Macro implementations


static void FCD_ADC0_SampleADC()
{
	
		#define MX_ADC_CHANNEL		0
		#define MX_ADC_SAMP_TIME 	40
		#define MX_ADC_CONV_SP		3
		#define MX_ADC_VREF_OPT		(1 - 0)

		char ddc;
		volatile char cnt;

		ddc = DDRC;

		//turn selected ADC on
		DDRC &= ~(1 << MX_ADC_CHANNEL);
		ADCSRA = (1 << ADEN) | MX_ADC_CONV_SP;
		ADMUX = (MX_ADC_VREF_OPT << REFS0) | (1 << ADLAR) | MX_ADC_CHANNEL;

		//wait the acquisition time
		cnt = 0;
		while (cnt < MX_ADC_SAMP_TIME) cnt++;

		//begin conversion and wait until it has finished
		ADCSRA |= (1 << ADSC);
		while(ADCSRA & (1 << ADSC));

		DDRC = ddc;

		#undef MX_ADC_CHANNEL
		#undef MX_ADC_SAMP_TIME
		#undef MX_ADC_CONV_SP
		#undef MX_ADC_VREF_OPT

}

static char FCD_ADC0_ReadAsByte()
{
	
		FCD_ADC0_SampleADC();

		return ADCH;

}

static short FCD_ADC0_ReadAsInt()
{
	
		int iRetVal;

		FCD_ADC0_SampleADC();

		iRetVal = (ADCL >> 6);
		iRetVal |= (ADCH << 2);
		return (iRetVal);

}

static float FCD_ADC0_ReadAsVoltage()
{
	

		int iSample;
		float fSample, fVoltage, fVperDiv;

		#define MX_ADC_VREF_V		500

		iSample = FCD_ADC0_ReadAsInt();											//Read as 10-bit Integer

		fVoltage = iSample * (float)MX_ADC_VREF_V / 102300.0;			//Find voltage by multiplying sample by resolution

		#undef MX_ADC_VREF_V
		return (fVoltage);

}

static void FCD_ADC0_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE)
{
	
		float fVoltage;

		fVoltage = FCD_ADC0_ReadAsVoltage();
		FCI_FLOAT_TO_STRING(fVoltage, 2, FCR_RETVAL, FCR_RETVAL_SIZE);	//Convert to String

}



//led7seg4(0): //Macro implementations


static void FCD_led7seg40_ShowDigit(char Digit, char Value, char DecimalPoint)
{
	    #define MX_7SEG4_SEGMENT_PORT  PORTD
	    #define MX_7SEG4_SEGMENT_DDR   DDRD


	    #define MX_7SEG4_COMMON_PORT   PORTC
	    #define MX_7SEG4_COMMON_DDR    DDRC


		if (Digit <= 3)
		{
			//set pattern arrays for the display

			const char cCommonArray[] = {8, 4, 1, 1};
			const char cSegmentArray[] = {64, 121, 36, 48, 25, 18, 2, 120, 0, 24};


			//get pattern for digit
			char cSegmentValue = cSegmentArray[Value % 10];
			if (DecimalPoint) cSegmentValue = cSegmentValue & 255;

			//set up ports
			MX_7SEG4_COMMON_DDR = MX_7SEG4_COMMON_DDR | ~241;
			MX_7SEG4_SEGMENT_DDR = MX_7SEG4_SEGMENT_DDR | ~0;

			//display the digit
	    	#if (1 == 1)
				//common anode
				MX_7SEG4_SEGMENT_PORT = cSegmentValue;
				MX_7SEG4_COMMON_PORT = (MX_7SEG4_COMMON_PORT & 241) | cCommonArray[Digit];
			#else
				//common cathode
				MX_7SEG4_SEGMENT_PORT = (MX_7SEG4_SEGMENT_PORT | ~0) & ~cSegmentValue;
				MX_7SEG4_COMMON_PORT = (MX_7SEG4_COMMON_PORT | ~241) & ~cCommonArray[Digit];
			#endif
		}

	    #undef MX_7SEG4_SEGMENT_PORT
	    #undef MX_7SEG4_SEGMENT_DDR
	    #undef MX_7SEG4_COMMON_PORT
	    #undef MX_7SEG4_COMMON_DDR

}



//EEPROM(0): //Macro implementations


static char FCD_EEPROM0_EEPROMRead(short addr)
{
	  char data = 0;

	  #ifdef MX_EE

		#ifdef EEWE
			while (test_bit(EECR, EEWE));
		#else
			while (test_bit(EECR, EEPE));
		#endif

		data = eeprom_read_byte((unsigned char *)addr);
	  #else
	    #pragma error "Chip does not have EEPROM memory"
	  #endif

	  return (data);


}

static void FCD_EEPROM0_WriteEEPROM(short addr, char data)
{
	
	  #ifdef MX_EE

		#ifdef EEWE
			while (test_bit(EECR, EEWE));
		#else
			while (test_bit(EECR, EEPE));
		#endif

		cli();
		eeprom_write_byte((unsigned char *)addr, data);
		sei();
	  #else
		#pragma error Chip does not have EEPROM memory
	  #endif

}

//Macro implementations

char FCM_plus()
{
	
	char FCR_RETVAL;

	//?????? ??????????
	//?????? ??????????: z0=EEPROM(0)::Read(0)
	FCV_Z0 = FCD_EEPROM0_EEPROMRead(0);


	//?????? ??????????
	//?????? ??????????: z1=EEPROM(0)::Read(1)
	FCV_Z1 = FCD_EEPROM0_EEPROMRead(1);


	//?????? ??????????
	//?????? ??????????: z2=EEPROM(0)::Read(2)
	FCV_Z2 = FCD_EEPROM0_EEPROMRead(2);


	//?????? ??????????
	//?????? ??????????: znak=EEPROM(0)::Read(5)
	FCV_ZNAK = FCD_EEPROM0_EEPROMRead(5);


	//???????
	//???????: znak=1?
	if (FCV_ZNAK==1)
	{
		//??????? ? ????? ??????????
		//??????? ? ????? ??????????: [B]: B
		goto FCC_plus_B;


	}


	//???????
	//???????: ustan<0?
	if (FCV_USTAN<0)
	{
		//????? ??????????
		//????? ??????????: [B]: B
FCC_plus_B:
;


		//??????????
		//??????????:
		//  ustan = -(z2*100+z1*10+z0)
		FCV_USTAN = -(FCV_Z2*100+FCV_Z1*10+FCV_Z0);
		

	} else {
		//??????????
		//??????????:
		//  ustan = z2*100+z1*10+z0
		FCV_USTAN = FCV_Z2*100+FCV_Z1*10+FCV_Z0;
		

	}


	//?????????????
	//?????????????: sw?
	switch (FCV_SW)
	{
		case 32:
		{
			//???????
			//???????: ustan<=5?
			if (FCV_USTAN<=5)
			{
			} else {
				//??????????
				//??????????:
				//  ustan = ustan-1
				FCV_USTAN = FCV_USTAN-1;
				

			}


			//????????
			//????????: 10 ??
			delay_ms(10);


			//??????????
			//??????????:
			//  bn = ustan
			FCV_BN = FCV_USTAN;
			

			//????? ??????????
			//????? ??????????: [A]: A
FCC_plus_A:
;


			//???????
			//???????: bn<0?
			if (FCV_BN<0)
			{
				//??????????
				//??????????:
				//  z2 = -bn/100
				//  z1 = -(bn-100*z2)/10
				//  z0 = -bn-(100*z2+10*z1)
				FCV_Z2 = -FCV_BN/100;
				FCV_Z1 = -(FCV_BN-100*FCV_Z2)/10;
				FCV_Z0 = -FCV_BN-(100*FCV_Z2+10*FCV_Z1);
				

				//?????? ??????????
				//?????? ??????????: EEPROM(0)::Write(5, 1)
				FCD_EEPROM0_WriteEEPROM(5, 1);


			} else {
				//??????????
				//??????????:
				//  z2 = bn/100
				//  z1 = (bn-100*z2)/10
				//  z0 = bn-(100*z2+10*z1)
				FCV_Z2 = FCV_BN/100;
				FCV_Z1 = (FCV_BN-100*FCV_Z2)/10;
				FCV_Z0 = FCV_BN-(100*FCV_Z2+10*FCV_Z1);
				

				//?????? ??????????
				//?????? ??????????: EEPROM(0)::Write(5, 0)
				FCD_EEPROM0_WriteEEPROM(5, 0);


			}


			//?????? ??????????
			//?????? ??????????: EEPROM(0)::Write(0, z0)
			FCD_EEPROM0_WriteEEPROM(0, FCV_Z0);


			//?????? ??????????
			//?????? ??????????: EEPROM(0)::Write(1, z1)
			FCD_EEPROM0_WriteEEPROM(1, FCV_Z1);


			//?????? ??????????
			//?????? ??????????: EEPROM(0)::Write(2, z2)
			FCD_EEPROM0_WriteEEPROM(2, FCV_Z2);


			break;
		}

		case 16:
		{
			//???????
			//???????: ustan>=35?
			if (FCV_USTAN>=35)
			{
			} else {
				//??????????
				//??????????:
				//  ustan = ustan + 1
				FCV_USTAN = FCV_USTAN + 1;
				

			}


			//????????
			//????????: 10 ??
			delay_ms(10);


			//??????????
			//??????????:
			//  bn = ustan
			FCV_BN = FCV_USTAN;
			

			//??????? ? ????? ??????????
			//??????? ? ????? ??????????: [A]: A
			goto FCC_plus_A;


			break;
		}

	}


	//??????????
	//??????????:
	//  bn = ustan
	FCV_BN = FCV_USTAN;
	

	return (FCR_RETVAL);
}

char FCM_ust()
{
	
	char FCR_RETVAL;

	//????
	//????: While 1
	while (1)
	{
		//????
		//????: B3 -> sw
		DDRB = DDRB & 0xf7;
		FCV_SW = ((PINB & 0x08) == 0x08);


		//???????
		//???????: sw=1?
		if (FCV_SW==1)
		{
			//??????? ? ????? ??????????
			//??????? ? ????? ??????????: [A]: A
			goto FCC_ust_A;


		}


		//????
		//????: ???? B -> sw
		DDRB = DDRB & 0xcf;
		FCV_SW = PINB & 0x30;


		//?????
		//?????: plus
		FCM_plus();


		//????
		//????: ???? 1 ???
		for (FCLV_LOOP2=0; FCLV_LOOP2<1; FCLV_LOOP2++)
		{
			//???????
			//???????: z2=0?
			if (FCV_Z2==0)
			{
			} else {
				//?????
				//?????: 0 -> ???? B
				DDRB = DDRB | 0xc0;
				PORTB = (PORTB & 0x3f) | 0;


				//?????? ??????????
				//?????? ??????????: led7seg4(0)::???????? ?????(2, z2, 0)
				FCD_led7seg40_ShowDigit(2, FCV_Z2, 0);


			}


			//????????
			//????????: 10 ??
			delay_ms(10);


			//???????
			//???????: z2=0 AND z1=0?
			if (FCV_Z2==0 & FCV_Z1==0)
			{
			} else {
				//?????
				//?????: 0 -> ???? B
				DDRB = DDRB | 0xc0;
				PORTB = (PORTB & 0x3f) | 0;


				//?????? ??????????
				//?????? ??????????: led7seg4(0)::???????? ?????(1, z1, 0)
				FCD_led7seg40_ShowDigit(1, FCV_Z1, 0);


			}


			//????????
			//????????: 10 ??
			delay_ms(10);


			//?????
			//?????: 0 -> ???? B
			DDRB = DDRB | 0xc0;
			PORTB = (PORTB & 0x3f) | 0;


			//?????? ??????????
			//?????? ??????????: led7seg4(0)::???????? ?????(0, z0, 0)
			FCD_led7seg40_ShowDigit(0, FCV_Z0, 0);


			//????????
			//????????: 10 ??
			delay_ms(10);


			//?????
			//?????: 0 -> ???? B
			DDRB = DDRB | 0xc0;
			PORTB = (PORTB & 0x3f) | 0;


		}


	}


	//????? ??????????
	//????? ??????????: [A]: A
FCC_ust_A:
;


	return (FCR_RETVAL);
}

short FCM_izm()
{
	
	short FCR_RETVAL;

	//?????? ??????????
	//?????? ??????????: tmp=ADC(0)::?????? ?a? Int
	FCV_TMP = FCD_ADC0_ReadAsInt();


	//??????????
	//??????????:
	//  tmp = tmp*30/306
	FCV_TMP = FCV_TMP*30/306;
	

	return (FCR_RETVAL);
}

int main()
{
	
	//Initialisation
	MCUCSR=0x00;
	wdt_disable();


	//Interrupt initialisation code
	
	//plus
	//?????: plus
	FCM_plus();


	//????
	//????: While 1
	while (1)
	{
		//????
		//????: ???? 1 ???
		for (FCLV_LOOP1=0; FCLV_LOOP1<1; FCLV_LOOP1++)
		{
			//????
			//????: B3 -> sw
			DDRB = DDRB & 0xf7;
			FCV_SW = ((PINB & 0x08) == 0x08);


			//???????
			//???????: sw=0?
			if (FCV_SW==0)
			{
				//?????
				//?????: ust
				FCM_ust();


			}


			//??????????
			//??????????:
			//  bn = tmp
			FCV_BN = FCV_TMP;
			

			//???????
			//???????: bn<0?
			if (FCV_BN<0)
			{
				//??????????
				//??????????:
				//  z2 = -bn/100
				//  z1 = -(bn-100*z2)/10
				//  z0 = -bn-(100*z2+10*z1)
				FCV_Z2 = -FCV_BN/100;
				FCV_Z1 = -(FCV_BN-100*FCV_Z2)/10;
				FCV_Z0 = -FCV_BN-(100*FCV_Z2+10*FCV_Z1);
				

				//???????
				//???????: bn>-10?
				if (FCV_BN>-10)
				{
					//?????
					//?????: 1 -> B1
					DDRB = DDRB | 0x02;
					if (1)
						PORTB = (PORTB & 0xfd) | 0x02;
					else
						PORTB = PORTB & 0xfd;


				} else {
					//?????
					//?????: 1 -> B1
					DDRB = DDRB | 0x02;
					if (1)
						PORTB = (PORTB & 0xfd) | 0x02;
					else
						PORTB = PORTB & 0xfd;


				}


				//????????
				//????????: 500 ??
				delay_ms(255);
				delay_ms(245);


				//?????
				//?????: 0 -> B1
				DDRB = DDRB | 0x02;
				if (0)
					PORTB = (PORTB & 0xfd) | 0x02;
				else
					PORTB = PORTB & 0xfd;


				//????????
				//????????: 10 ??
				delay_ms(10);


				//?????
				//?????: 0 -> ???? B
				DDRB = DDRB | 0xc0;
				PORTB = (PORTB & 0x3f) | 0;


				//?????
				//?????: 255 -> ???? B
				DDRB = DDRB | 0x7f;
				PORTB = (PORTB & 0x80) | 255;


			} else {
				//??????????
				//??????????:
				//  z2 = bn/100
				//  z1 = (bn-100*z2)/10
				//  z0 = bn-(100*z2+10*z1)
				FCV_Z2 = FCV_BN/100;
				FCV_Z1 = (FCV_BN-100*FCV_Z2)/10;
				FCV_Z0 = FCV_BN-(100*FCV_Z2+10*FCV_Z1);
				

			}


			//???????
			//???????: z2=0?
			if (FCV_Z2==0)
			{
			} else {
				//?????
				//?????: 0 -> ???? B
				DDRB = DDRB | 0xc0;
				PORTB = (PORTB & 0x3f) | 0;


				//?????? ??????????
				//?????? ??????????: led7seg4(0)::???????? ?????(2, z2, 0)
				FCD_led7seg40_ShowDigit(2, FCV_Z2, 0);


			}


			//????????
			//????????: 10 ??
			delay_ms(10);


			//???????
			//???????: z2=0 AND z1=0?
			if (FCV_Z2==0 & FCV_Z1==0)
			{
			} else {
				//?????
				//?????: 0 -> ???? B
				DDRB = DDRB | 0xc0;
				PORTB = (PORTB & 0x3f) | 0;


				//?????? ??????????
				//?????? ??????????: led7seg4(0)::???????? ?????(1, z1, 0)
				FCD_led7seg40_ShowDigit(1, FCV_Z1, 0);


			}


			//????????
			//????????: 10 ??
			delay_ms(10);


			//?????
			//?????: 0 -> ???? B
			DDRB = DDRB | 0xc0;
			PORTB = (PORTB & 0x3f) | 0;


			//?????? ??????????
			//?????? ??????????: led7seg4(0)::???????? ?????(0, z0, 0)
			FCD_led7seg40_ShowDigit(0, FCV_Z0, 0);


			//????????
			//????????: 10 ??
			delay_ms(10);


			//?????
			//?????: 0 -> ???? B
			DDRB = DDRB | 0xc0;
			PORTB = (PORTB & 0x3f) | 0;


		}


		//?????
		//?????: izm
		FCM_izm();


		//???????
		//???????: tmp<ustan?
		if (FCV_TMP<FCV_USTAN)
		{
			//?????
			//?????: 1 -> B1
			DDRB = DDRB | 0x02;
			if (1)
				PORTB = (PORTB & 0xfd) | 0x02;
			else
				PORTB = PORTB & 0xfd;


		} else {
			//?????
			//?????: 0 -> B1
			DDRB = DDRB | 0x02;
			if (0)
				PORTB = (PORTB & 0xfd) | 0x02;
			else
				PORTB = PORTB & 0xfd;


		}


	}


	mainendloop: goto mainendloop;
}



